#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <strings.h>

#ifdef GCC32HACK
#include "win32gcc.h"
#endif

#define AFC_BLOCKALIGN 0x8000

int main(int argc, char *argv[]) {
FILE *fl, *f;
int fe, sz, i, ps;
char *s;
void *p;
  printf("Mass Effect 2 .AFC extractor\n(c) CTPAX-X Team 2010,2015\nhttp://www.CTPAX-X.org/\n\n");
  if (argc != 2) {
    printf("Usage: afcextr filename.afc\n\n");
    return(1);
  }
  fl = fopen(argv[1], "rb");
  if (!fl) {
    printf("Error: can\'t open file: %s\n\n", argv[1]);
    return(2);
  }
  fseek(fl, 0, SEEK_END);
  fe = ftell(fl);
  fseek(fl, 0, SEEK_SET);
  i = 0;
  ps = strlen(argv[1]);
  s = (char *) malloc(ps + 1 + 8);
  if (s) {
     strcpy(s, argv[1]);
     while (ftell(fl) + 4 < fe) {
      sz = 0;
      fread(&sz, 4, 1, fl);
      /* RIFF */
      if (sz == 0x46464952) {
        i++;
        sprintf(&s[ps - 3], "%03d.wav", i);
        printf(s);
        sz = 0;
        fread(&sz, 4, 1, fl);
        fseek(fl, -8, SEEK_CUR);
        sz += 8;
        p = malloc(sz);
        if (p) {
          fread(p, 1, sz, fl);
          f = fopen(s, "wb");
          if (f) {
            fwrite(p, 1, sz, f);
            fclose(f);
          }
          free(p);
        }
        sz = (ftell(fl) + AFC_BLOCKALIGN - 1) / AFC_BLOCKALIGN;
        fseek(fl, sz * AFC_BLOCKALIGN, SEEK_SET);
        printf("\n");
      } else {
        fseek(fl, -3, SEEK_CUR);
      }
    }
    free(s);
  }
  fclose(fl);
  return(0);
}
